﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SpreadNETGetLinks
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            fpSpread1.AsWorkbook().WorkbookSet.CalculationEngine.CalcFeatures &= GrapeCity.Spreadsheet.CalcFeatures.DynamicArray;
            fpSpread1.AddCustomFunction(new GetLinksFunction());
        }

        private void OpenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog d = new OpenFileDialog();
            d.Filter = "Excel Workbook (*.XLSX;*.XLSM;*.XLS)|*.XLSX;*.XLSM;*.XLS";
            d.Title = "Open Excel Workbook";
            if (d.ShowDialog() == DialogResult.OK)
                fpSpread1.OpenExcel(d.FileName);
        }

        private void SaveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog d = new SaveFileDialog();
            d.Filter = "Excel Workbook (*.XLSX)|*.XLSX|Excel Macro-enabled Workbook (*.XLSM)|*.XLSM|Excel 97 Workbook (*.XLS)|*.XLS";
            d.FilterIndex = 0;
            if (d.ShowDialog() == DialogResult.OK)
            {
                string fname = d.FileName.ToUpper();
                if (fname.EndsWith("XLS"))
                { // save XLS format
                    fpSpread1.SaveExcel(d.FileName, FarPoint.Excel.ExcelSaveFlags.NoFlagsSet);
                }
                else if (fname.EndsWith("XLSM"))
                { // save XLSM format
                    fpSpread1.SaveExcel(d.FileName, FarPoint.Excel.ExcelSaveFlags.DocumentCaching | FarPoint.Excel.ExcelSaveFlags.UseOOXMLFormat);
                }
                else
                { // save XLSX format
                    fpSpread1.SaveExcel(d.FileName, FarPoint.Excel.ExcelSaveFlags.UseOOXMLFormat);
                }
            }
        }
    }
}
